{{ define "main" }}
  {{ $vulnerabilities := .Site.Data.vulnerabilities }}
  {{ $total := 0 }}
  {{ $aging_vulns := dict }}
  {{ range $vulnerabilities.aging }}
    {{ $total = add $total .all_time }}
    {{ $aging_vulns = merge $aging_vulns (dict .severity (.all_time | default 0)) }}
  {{ end }}

  {{ if eq $total 0 }}
    <p>No Vulnerabilities</p>
  {{ else }}
    <h2>Triaged - Last 30 days</h2>

    <div class="table-responsive">
      <table class="table table-striped table-hover">
        <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Project</th>
            <th scope="col" class="text-end">Dismissed</th>
            <th scope="col" class="text-end">Confirmed</th>
            <th scope="col" class="text-end">Resolved</th>
            <th scope="col" class="text-end">Total</th>
          </tr>
        </thead>
        <tbody id="listTable">
          {{ $counter := 0 }}
          {{ $total_triaged := 0 }}
          {{ range $vulnerabilities.triage_ratios }}
            {{ $counter = add $counter 1 }}
            {{ $total := 0 }}
            {{ $total = add $total .total_dismissed }}
            {{ $total = add $total .total_confirmed }}
            {{ $total = add $total .total_resolved }}
            {{ $total_triaged = add $total_triaged $total }}
            <tr>
              <th scope="row">{{ $counter }}</th>
              <td>
                <a href="{{ printf "projects/%s" .path_with_namespace | urlize | relURL }}"
                  >{{ .path_with_namespace }}</a
                >
              </td>
              <td class="text-end">
                {{ .total_dismissed | lang.FormatNumber 0 }}
                <i
                  class="fas fa-info-circle text-secondary"
                  data-bs-toggle="tooltip"
                  data-bs-placement="top"
                  title="Critical: {{ .dismissed_critical| lang.FormatNumber 0 }} - High: {{ .dismissed_high | lang.FormatNumber 0 }} - Unknown: {{ .dismissed_unknown | lang.FormatNumber 0 }} - Medium: {{ .dismissed_medium | lang.FormatNumber 0 }} - Low: {{ .dismissed_low | lang.FormatNumber 0 }} - Info: {{ .dismissed_info | lang.FormatNumber 0 }}"></i>
              </td>
              <td class="text-end">
                {{ .total_confirmed | lang.FormatNumber 0 }}
                <i
                  class="fas fa-info-circle text-secondary"
                  data-bs-toggle="tooltip"
                  data-bs-placement="top"
                  title="Critical: {{ .confirmed_critical | lang.FormatNumber 0 }} - High: {{ .confirmed_high | lang.FormatNumber 0 }} - Unknown: {{ .confirmed_unknown | lang.FormatNumber 0 }} - Medium: {{ .confirmed_medium | lang.FormatNumber 0 }} - Low: {{ .confirmed_low | lang.FormatNumber 0 }} - Info: {{ .confirmed_info | lang.FormatNumber 0 }}"></i>
              </td>
              <td class="text-end">
                {{ .total_resolved | lang.FormatNumber 0 }}
                <i
                  class="fas fa-info-circle text-secondary"
                  data-bs-toggle="tooltip"
                  data-bs-placement="top"
                  title="Critical: {{ .resolved_critical | lang.FormatNumber 0 }} - High: {{ .resolved_high | lang.FormatNumber 0 }} - Unknown: {{ .resolved_unknown | lang.FormatNumber 0 }} - Medium: {{ .resolved_medium | lang.FormatNumber 0 }} - Low: {{ .resolved_low | lang.FormatNumber 0 }} - Info: {{ .resolved_info | lang.FormatNumber 0 }}"></i>
              </td>
              <td class="text-end">{{ $total | lang.FormatNumber 0 }}</td>
            </tr>
          {{ end }}
        </tbody>
        <tfoot>
          <tr>
            <td colspan="5"></td>
            <td class="text-end"><strong>{{ $total_triaged | lang.FormatNumber 0 }}</strong></td>
          </tr>

          <tr></tr>
        </tfoot>
      </table>
    </div>

    {{ if gt $total_triaged 0 }}
      <h2>Triage Burndown</h2>

      <p>
        Total number of vulnerabilities / triaged in the last 30 days / 30 days:
        <strong>
          {{ $total | lang.FormatNumber 0 }} / {{ $total_triaged | lang.FormatNumber 0 }} / 30 =
          {{ div $total (div $total_triaged 30) | lang.FormatNumber 0 }}
        </strong>
        days to triage everything at the same rate, or by severity:
      </p>

      <div class="row">
        {{ range $i,$s := (slice "critical" "high" "unknown" "medium" "low" "info") }}
          <div class="col-xl-2 col-md-6 mb-4">
            <div class="card border-left-primary shadow h-100 py-2">
              <div class="card-body">
                <div class="row no-gutters align-items-center">
                  <div class="col mr-2">
                    <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                      {{ partial "severity" $s }}
                    </div>
                    {{ $days_to_zero := div ((index $aging_vulns $s) | default 0) (div $total_triaged 30) }}
                    <div class="h5 mb-0 font-weight-bold text-gray-800">
                      {{ if lt $days_to_zero 1 }}
                        <1 day
                      {{ else }}
                        {{ $days_to_zero | lang.FormatNumber 0 }} days
                      {{ end }}
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        {{ end }}
      </div>
    {{ end }}


    <hr />

    <h2>Velocity (last 6 months)</h2>

    {{ $total := newScratch }}
    {{ range $vulnerabilities.velocity_by_month }}
      {{ $total.Set "critical" (add ($total.Get "critical" | default 0) .critical) }}
      {{ $total.Set "high" (add ($total.Get "critical" | default 0) .high) }}
      {{ $total.Set "unknown" (add ($total.Get "unknown" | default 0) .unknown) }}
      {{ $total.Set "medium" (add ($total.Get "medium" | default 0) .medium) }}
      {{ $total.Set "low" (add ($total.Get "low" | default 0) .low) }}
      {{ $total.Set "info" (add ($total.Get "info" | default 0) .info) }}
    {{ end }}


    <div class="row">
      {{ range $i,$s := (slice "critical" "high" "unknown" "medium" "low" "info") }}
        <div class="col-xl-2 col-md-6 mb-4">
          <div class="card border-left-primary shadow h-100 py-2">
            <div class="card-body">
              <div class="row no-gutters align-items-center">
                <div class="col mr-2">
                  <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                    {{ partial "severity" $s }}
                  </div>
                  <div class="h5 mb-0 font-weight-bold text-gray-800">
                    {{ $total.Get $s | lang.FormatNumber 0 }} dismissed
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      {{ end }}
    </div>

    <ul class="nav nav-tabs" id="velocity_tabs" role="tablist">
      <li class="nav-item" role="presentation">
        <button
          class="nav-link active"
          id="week-tab"
          data-bs-toggle="tab"
          data-bs-target="#by_week_tab"
          type="button"
          role="tab"
          aria-controls="home"
          aria-selected="true">
          By Week
        </button>
      </li>
      <li class="nav-item" role="presentation">
        <button
          class="nav-link"
          id="month-tab"
          data-bs-toggle="tab"
          data-bs-target="#by_month_tab"
          type="button"
          role="tab"
          aria-controls="home"
          aria-selected="true">
          By Month
        </button>
      </li>
    </ul>

    <div class="tab-content" id="velocity_tab_content">
      <div
        class="tab-pane fade show active"
        id="by_week_tab"
        role="tabpanel"
        aria-labelledby="week_tab">
        <div class="row">
          <div class="col-lg">
            <canvas id="weeklyChart"></canvas>
          </div>
          <div class="col-lg table-responsive">
            <table class="table table-striped table-hover">
              <thead>
                <tr class="text-end">
                  <th scope="col" class="text-start">Week #</th>
                  <th scope="col" class="text-start">Week Start</th>
                  <th scope="col" class="text-start">Week End</th>
                  <th scope="col">Dismissed</th>
                  <th scope="col">Confirmed</th>
                  <th scope="col">Resolved</th>
                  <th scope="col">Total</th>
                </tr>
              </thead>
              <tbody id="listTable">
                {{ $total_dismissed := 0 }}
                {{ $total_confirmed := 0 }}
                {{ $total_resolved := 0 }}
                {{ range $vulnerabilities.velocity_by_week }}
                  <tr class="text-end">
                    <td scope="row" class="text-start">{{ .WeekNumber }}</td>
                    <td scope="row" class="text-start">{{ .WeekStart }}</td>
                    <td scope="row" class="text-start">{{ .WeekEnd }}</td>
                    <td scope="row">
                      {{ $dismissed := (add .dismissed_critical (add .dismissed_high (add .dismissed_unknown (add .dismissed_medium (add .dismissed_low .dismissed_info))))) }}
                      {{ $total_dismissed = add $total_dismissed $dismissed }}
                      {{ $dismissed | lang.FormatNumber 0 }}
                      <i
                        class="fas fa-info-circle text-secondary"
                        data-bs-toggle="tooltip"
                        data-bs-placement="top"
                        title="Critical: {{ .dismissed_critical| lang.FormatNumber 0 }} - High: {{ .dismissed_high | lang.FormatNumber 0 }} - Unknown: {{ .dismissed_unknown | lang.FormatNumber 0 }} - Medium: {{ .dismissed_medium | lang.FormatNumber 0 }} - Low: {{ .dismissed_low | lang.FormatNumber 0 }} - Info: {{ .dismissed_info | lang.FormatNumber 0 }}"></i>
                    </td>
                    <td scope="row">
                      {{ $confirmed := (add .confirmed_critical (add .confirmed_high (add .confirmed_unknown (add .confirmed_medium (add .confirmed_low .confirmed_info))))) }}
                      {{ $total_confirmed = add $total_confirmed $confirmed }}
                      {{ $confirmed | lang.FormatNumber 0 }}
                      <i
                        class="fas fa-info-circle text-secondary"
                        data-bs-toggle="tooltip"
                        data-bs-placement="top"
                        title="Critical: {{ .confirmed_critical| lang.FormatNumber 0 }} - High: {{ .confirmed_high | lang.FormatNumber 0 }} - Unknown: {{ .confirmed_unknown | lang.FormatNumber 0 }} - Medium: {{ .confirmed_medium | lang.FormatNumber 0 }} - Low: {{ .confirmed_low | lang.FormatNumber 0 }} - Info: {{ .confirmed_info | lang.FormatNumber 0 }}"></i>
                    </td>
                    <td scope="row">
                      {{ $resolved := (add .resolved_critical (add .resolved_high (add .resolved_unknown (add .resolved_medium (add .resolved_low .resolved_info))))) }}
                      {{ $total_resolved = add $total_resolved $resolved }}
                      {{ $resolved | lang.FormatNumber 0 }}
                      <i
                        class="fas fa-info-circle text-secondary"
                        data-bs-toggle="tooltip"
                        data-bs-placement="top"
                        title="Critical: {{ .resolved_critical| lang.FormatNumber 0 }} - High: {{ .resolved_high | lang.FormatNumber 0 }} - Unknown: {{ .resolved_unknown | lang.FormatNumber 0 }} - Medium: {{ .resolved_medium | lang.FormatNumber 0 }} - Low: {{ .resolved_low | lang.FormatNumber 0 }} - Info: {{ .resolved_info | lang.FormatNumber 0 }}"></i>
                    </td>
                    <td scope="row"><strong>{{ .total | lang.FormatNumber 0 }}</strong></td>
                  </tr>
                {{ end }}
              </tbody>
              <tfoot>
                <tr class="text-end">
                  <td colspan="4">{{ $total_dismissed | lang.FormatNumber 0 }}</td>
                  <td>{{ $total_confirmed | lang.FormatNumber 0 }}</td>
                  <td>{{ $total_resolved | lang.FormatNumber 0 }}</td>
                  <td>
                    {{ (add $total_dismissed (add $total_confirmed $total_resolved)) | lang.FormatNumber 0 }}
                  </td>
                </tr>
              </tfoot>
            </table>
          </div>
        </div>
      </div>

      <div class="tab-pane fade" id="by_month_tab" role="tabpanel" aria-labelledby="month_tab">
        <div class="row">
          <div class="col-lg">
            <canvas id="monthlyChart"></canvas>
          </div>
          <div class="col-lg table-responsive">
            <table class="table table-striped table-hover">
              <thead>
                <tr class="text-end">
                  <th scope="col" class="text-start">Month #</th>
                  <th scope="col">Dismissed</th>
                  <th scope="col">Confirmed</th>
                  <th scope="col">Resolved</th>
                  <th scope="col">Total</th>
                </tr>
              </thead>
              <tbody id="listTable">
                {{ $total_dismissed := 0 }}
                {{ $total_confirmed := 0 }}
                {{ $total_resolved := 0 }}
                {{ range $vulnerabilities.velocity_by_month }}
                  <tr class="text-end">
                    <td scope="row" class="text-start">{{ .month }}</td>
                    <td scope="row">
                      {{ $dismissed := (add .dismissed_critical (add .dismissed_high (add .dismissed_unknown (add .dismissed_medium (add .dismissed_low .dismissed_info))))) }}
                      {{ $total_dismissed = add $total_dismissed $dismissed }}
                      {{ $dismissed | lang.FormatNumber 0 }}
                      <i
                        class="fas fa-info-circle text-secondary"
                        data-bs-toggle="tooltip"
                        data-bs-placement="top"
                        title="Critical: {{ .dismissed_critical| lang.FormatNumber 0 }} - High: {{ .dismissed_high | lang.FormatNumber 0 }} - Unknown: {{ .dismissed_unknown | lang.FormatNumber 0 }} - Medium: {{ .dismissed_medium | lang.FormatNumber 0 }} - Low: {{ .dismissed_low | lang.FormatNumber 0 }} - Info: {{ .dismissed_info | lang.FormatNumber 0 }}"></i>
                    </td>
                    <td scope="row">
                      {{ $confirmed := (add .confirmed_critical (add .confirmed_high (add .confirmed_unknown (add .confirmed_medium (add .confirmed_low .confirmed_info))))) }}
                      {{ $total_confirmed = add $total_confirmed $confirmed }}
                      {{ $confirmed | lang.FormatNumber 0 }}
                      <i
                        class="fas fa-info-circle text-secondary"
                        data-bs-toggle="tooltip"
                        data-bs-placement="top"
                        title="Critical: {{ .confirmed_critical| lang.FormatNumber 0 }} - High: {{ .confirmed_high | lang.FormatNumber 0 }} - Unknown: {{ .confirmed_unknown | lang.FormatNumber 0 }} - Medium: {{ .confirmed_medium | lang.FormatNumber 0 }} - Low: {{ .confirmed_low | lang.FormatNumber 0 }} - Info: {{ .confirmed_info | lang.FormatNumber 0 }}"></i>
                    </td>
                    <td scope="row">
                      {{ $resolved := (add .resolved_critical (add .resolved_high (add .resolved_unknown (add .resolved_medium (add .resolved_low .resolved_info))))) }}
                      {{ $total_resolved = add $total_resolved $resolved }}
                      {{ $resolved | lang.FormatNumber 0 }}
                      <i
                        class="fas fa-info-circle text-secondary"
                        data-bs-toggle="tooltip"
                        data-bs-placement="top"
                        title="Critical: {{ .resolved_critical| lang.FormatNumber 0 }} - High: {{ .resolved_high | lang.FormatNumber 0 }} - Unknown: {{ .resolved_unknown | lang.FormatNumber 0 }} - Medium: {{ .resolved_medium | lang.FormatNumber 0 }} - Low: {{ .resolved_low | lang.FormatNumber 0 }} - Info: {{ .resolved_info | lang.FormatNumber 0 }}"></i>
                    </td>
                    <td scope="row"><strong>{{ .total | lang.FormatNumber 0 }}</strong></td>
                  </tr>
                {{ end }}
              </tbody>
              <tfoot>
                <tr class="text-end">
                  <td colspan="2">{{ $total_dismissed | lang.FormatNumber 0 }}</td>
                  <td>{{ $total_confirmed | lang.FormatNumber 0 }}</td>
                  <td>{{ $total_resolved | lang.FormatNumber 0 }}</td>
                  <td>
                    {{ (add $total_dismissed (add $total_confirmed $total_resolved)) | lang.FormatNumber 0 }}
                  </td>
                </tr>
              </tfoot>
            </table>
          </div>
        </div>
      </div>
    </div>

    {{ range $dest, $data := (dict "weeklyChart" $vulnerabilities.velocity_by_week "monthlyChart" $vulnerabilities.velocity_by_month) }}
<script>
const {{$dest | safeJS}}labels = [
    {{ range $data }}
    {{ if eq $dest "weeklyChart" }}
    'W{{ .WeekNumber }}',
    {{ else }}
    '{{ .month }}',
    {{end}}
    {{end}}
  ];
const {{$dest | safeJS}}data = {
  labels: {{$dest | safeJS}}labels,
  datasets: [
    {
      label: 'Critical',
      data: [
          {{ range $data }}
          {{ .critical }},
          {{ end }}
          ],
      backgroundColor: 'rgba(255, 99, 132, 0.3)',
      borderColor:     'rgb(255, 99, 132)',
      borderWidth: 1,

    }, {
      label: 'High',
      data: [
          {{ range $data }}
          {{ .high }},
          {{ end }}
          ],
      backgroundColor: 'rgba(255, 99, 132, 0.3)',
      borderColor:     'rgb(255, 99, 132)',
      borderWidth: 1,

    }, {
      label: 'Unknown',
      data: [
          {{ range $data }}
          {{ .unknown }},
          {{ end }}
          ],
      backgroundColor: 'rgba(89, 98, 105, 0.3)',
      borderColor:     'rgb(89, 98, 105)',
      borderWidth: 1,

    }, {
      label: 'Medium',
      data: [
          {{ range $data }}
          {{ .medium }},
          {{ end }}
          ],
      backgroundColor: 'rgba(254, 181, 13, 0.3)',
      borderColor:     'rgb(254, 181, 13)',
      borderWidth: 1,

    }, {
      label: 'Low',
      data: [
          {{ range $data }}
          {{ .low }},
          {{ end }}
          ],
      backgroundColor: 'rgba(89, 98, 105, 0.3)',
      borderColor:     'rgb(89, 98, 105)',
      borderWidth: 1,

    }, {
      label: 'Info',
      data: [
          {{ range $data }}
          {{ .info }},
          {{ end }}
          ],
      backgroundColor: 'rgba(89, 98, 105, 0.3)',
      borderColor:     'rgb(89, 98, 105)',
      borderWidth: 1,
    }
  ]
};

const {{$dest | safeJS}}config = {
  type: 'bar',
  data: {{$dest | safeJS}}data,
  options: {
    animations: {
      radius: {
        duration: 500,
        easing: 'linear',
        loop: (context) => context.active
      }
    },
    responsive: true,
    scales: {
      x: {
        stacked: true,
      },
      y: {
        stacked: true
      }
    }
  }
};

  var {{$dest | safeJS}} = new Chart(
      document.getElementById('{{ $dest | safeJS}}'),
      {{$dest | safeJS}}config
    );
</script>
    {{ end }}

  {{ end }}
{{ end }}
